package com.ruoyi.common.utils;

import org.apache.commons.codec.binary.Base64;
import javax.crypto.Cipher;
import java.security.*;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

/**
 * RSA加密解密
 *
 * @author ruoyi
 **/
public class RsaUtils
{
    // Rsa 私钥
    public static String privateKey = " -----BEGIN RSA PRIVATE KEY-----\n" +
            "MIIEpQIBAAKCAQEAnEeZMSY6UdmJRJzqbPb5h6iXW1PziRWHlwq7vfZ7Bslb3kKR\n" +
            "Va3TeGqiZsCCf7y5CuGS61multLKi/ABbS11LRTpUv+UAYm+edmM4TK/KdPbSExz\n" +
            "D8z8CZd6x0wek+uKSkDOZWlwlrH0cXSfTyY3uget7jEbU/0WJCbucKXrFiB34fl4\n" +
            "7RTgCBfcWHbCnIuEqV8h4mewvZDsluD55x4cv6vdlLS4NQ9CHkFWJjeViirjZscj\n" +
            "b4X8m31PTmRMQAzsKjmS0cm87Gtjv+VfQHBLaV962FVEZBF+D/809bunUxfAi0kX\n" +
            "D3K6OSYw0fvJo1sESOVntxjhKDng1ZXwoaIBcQIDAQABAoIBAQCJRQaVOkvNqzM8\n" +
            "Vkw/a+wgMYDJEoN+rK+NhzsDD6Zefq24G2aHCIkQYzHE6WF3C/DJUvv2x65oAj0x\n" +
            "D55hJKWg9JZBdgauFyx84Q8ym514AwPAjI4gmd/kGO8acY0GRsUQlb31K9leNG9O\n" +
            "3K42Go6mU6p95xpm+o3hMWUNA1/r7TdlIq7BB7pV4z+GYaVnAhPJP6JUddt8L8eO\n" +
            "Y0LCtLvE24FcXbkrHTMdBca+dfNeYT03Vvd1JYRxHr+VHFVh8Ov6adAQ/vejJ8Iu\n" +
            "+xcbgKjeQSAVBCjTu15q8mmW4ZVip0DRKjJ35EbWu8HMTqSTWEe+iZqHzvf/I2cz\n" +
            "3vBLCqoBAoGBAM9ErbanIyL3yfPwMfrQhxAqDLuJQaNraZvvG4VJKlJDtux2dT3Z\n" +
            "rIh+Qe0QEivuePbEb9fKPTVtdK/vJSOcmlgsJvFPqsfEvTF2CS01Me2YOjvQtheY\n" +
            "FZd9KR51kOA+9oQhnJIzUmIOJ9ERY/BS4xmWfj+Rb83WYzTQY9z1d2HRAoGBAMEF\n" +
            "9Gm37U2X3TX7A83dSJYVz7stWQ1aEqDJqfC8rOondti0Mkx2kKHJjEHSVBl0rpPT\n" +
            "lVxbhiaHO9QMlD5qOGfDnIxRiAA5MQn0PO3u6E27ZiMxx5di8ipLF1oRvT5FHwcy\n" +
            "RXL39lDMib2lBxzRT9InZZ4owgU3oTc6ZW1kz+2hAoGBALSvvnA4jBzzvo51mlx4\n" +
            "ZQXmYmsqYJpCDTLu4yLygX5toY3KRrLAi/QBfR9Ynz7FCZa18HpBx9JHtS2aYNoG\n" +
            "r1amRtyfAtZb4EK6D43ljbz+s+VpMRSodEo3xhzTiJS0ztqpIoEhVHQ+ut87NdBP\n" +
            "scKguzZXZwweFSX5dNUu9//BAoGBAIsTM0uIzl598VEXj2Ig8k/RX19KCUPphkp7\n" +
            "gwqFp0D/Nk5lZ2hYdVVc1sYGObotrCuu44ssFrhj7+OVPKrL9eAtvPoNNKSUkJTP\n" +
            "eacl4BNB1xG8qEaXcEyw1h57cZMQUo7o1clEiCEnfoc6BKnq1kxhPoJ6c3E2593X\n" +
            "IYV0gayBAoGARE9gbxgCP8YW1AvOB1nEkyWNR40qEKhAniQP+pg3h7o5K/7aUcew\n" +
            "UnJsYdOm3JPA8zkGbXWupIaqzVwKYVNEVqt0lJ+L5jbIrPXtarHoBEnH1MB0spZ5\n" +
            "ZwtgQpYOR2MbVRDKzKf+YbhcKMjt6U5JqiAf/JYSPCkR0BCK8cQ8+TI=\n" +
            "-----END RSA PRIVATE KEY-----";
    /**
     * 私钥解密
     *
     * @param text 待解密的文本
     * @return 解密后的文本
     */
    public static String decryptByPrivateKey(String text) throws Exception
    {
        return decryptByPrivateKey(privateKey, text);
    }

    /**
     * 私钥解密
     *
     * @param privateKeyString 私钥
     * @param text 待解密的文本
     * @return 解密后的文本
     */
    public static String decryptByPrivateKey(String privateKeyString, String text) throws Exception
    {
        PKCS8EncodedKeySpec pkcs8EncodedKeySpec5 = new PKCS8EncodedKeySpec(Base64.decodeBase64(privateKeyString));
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PrivateKey privateKey = keyFactory.generatePrivate(pkcs8EncodedKeySpec5);
        Cipher cipher = Cipher.getInstance("RSA/ECB/OAEPWithMD5AndMGF1Padding");
        cipher.init(Cipher.DECRYPT_MODE, privateKey);
        byte[] result = cipher.doFinal(Base64.decodeBase64(text));
        return new String(result);
    }
}